<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006-2016 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 流年 <liu21st@gmail.com>
// +----------------------------------------------------------------------

// 应用公共文件

/**
 * 下载或获取信息
 * @param string $url
 * @param string $file 下载文件时指定路径
 * @param array $options 头部文件
 */
function fetch_url($url, $file = null, $options = [])
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_FAILONERROR, 0);
    curl_setopt($ch, CURLOPT_ENCODING, 'gzip');
    curl_setopt($ch, CURLOPT_VERBOSE, 0);

    if (is_array($options) && count($options) > 0) {
        foreach ($options as $k => $v) {
            curl_setopt($ch, $k, $v);
        }
    }

    if ($file) {
        // Save the file to $file destination
        $out = @fopen($file, 'wb');
        if (!$out) {
            throw new Exception("Can't open " . __FUNCTION__ . "() file for read and write");
            return false;
        }
        curl_setopt($ch, CURLOPT_FILE, $out);
        @curl_exec($ch);
        fclose($out);
    } else {
        // Return the file string
        $file_get_contents = @curl_exec($ch);
    }
    if (curl_errno($ch)) {
        $curl_error = curl_error($ch);
        curl_close($ch);
        throw new Exception('Curl error ' . $curl_error);
        return false;
    }
    if ($file == null) {
        curl_close($ch);
        return $file_get_contents;
    }
}

function get_int_version($ver)
{
    return str_replace('.', '', $ver);
}

function build_key($domain)
{
    $key_1 = md5(\think\Config::get('salt') . time());
    $key_2 = md5($domain . \think\Config::get('salt'));
    $key_3 = md5(rand(1, 999)) . md5(rand(999, 99999));
    $key   = strtoupper(substr(md5(time()), 14, 4)) . ':' . $key_1 . $key_2 . $key_3;
    return $key;
}

/**
 * 文件解包
 * @param string @filename 压缩包的存储路径
 * @param string @path 解压后的目录
 * @return string 解包后的临时储存路径
 */
function unzip($filename, $path)
{
    return shell_exec("mkdir {$path} && cd {$path} && unzip -o -d ./ {$filename}");
}

/**
 * 文件打包
 * @param string $filename 打包后的文件
 * @param string $path 文件存储路径
 */
function mk_zip($filename, $path)
{
    return shell_exec("cd {$path} && zip -r {$filename} ./* && rm -rf {$path}");
}

/**
 * 获取域名(不带任何协议和后缀)
 */
function get_domain($domain)
{
    $domain = parse_url($domain);
    if (isset($domain['host'])) {
        $domain = $domain['host'];
    } elseif (isset($domain['path'])) {
        $f = strpos($domain['path'], '/');
        if ($f === false) {
            $domain = $domain['path'];
        } else {
            $domain = substr($domain['path'], 0, strpos($domain['path'], '/'));
        }

    } else {
        return false;
    }
    return $domain;
}
