<?php
namespace app\control\controller;

use think\Config;
use think\Controller;
use think\Loader;

class Make extends Controller
{
    private $update;

    public function create()
    {
        if ($this->request->get('domain') && $this->request->get('key') == Config::get('admin_key')) {
            Loader::model('License')->createLicense($this->request->get('domain'));
            exit(Loader::model('Invitation')->addKey($this->request->get('domain')));

        }
    }

    public function get()
    {
        $invitation = $this->request->post('key');
        $domain     = $this->request->post('domain');
        $domain     = get_domain($domain);
        if (empty($domain)) {
            return $this->error('辣鸡*5');
        }
        if (empty($invitation) || empty($domain)) {
            return $this->error('辣鸡!');
        }

        $invitation_info = Loader::model('Invitation')->getKeyInfo($invitation);
        if (empty($invitation_info)) {
            return $this->error('辣鸡*2');
        }

        if (!empty($invitation_info['invitation_domain']) && $invitation_info['invitation_domain'] != $domain) {
            var_dump($domain, $invitation_info['invitation_domain']);
            return $this->error('辣鸡*3');
        }

        if (!empty($invitation_info['update_at']) && ($invitation_info['update_at'] + 3600) < time()) {
            return $this->error('辣鸡*4');
        }

        Loader::model('Invitation')->useKey($invitation, $domain);
        $this->update = Loader::model('Update')->getLastInfo();
        $this->down($domain);
    }

    public function down($domain)
    {
        $zip_path = $this->makeZip('https://' . $domain);
        if (empty($zip_path)) {
            exit();
        }
        $size = filesize($zip_path);
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=chevereto_" . $this->update['update_version_raw'] . '.zip');
        header("Content-Length:" . $size);
        ob_clean();
        flush();
        readfile($zip_path);
        exit();
    }

    private function makeZip($domain)
    {
        $name = APP_PATH . '../runtime/temp/chevereto_' . md5($this->update['update_version_raw'] . '_' . $domain) . '.zip';
        if (is_file($name)) {
            return $name;
        }
        //创建临时文件夹和复制文件
        $temp_path = APP_PATH . "../runtime/temp/" . md5(time() . $domain);
        shell_exec("mkdir {$temp_path} && cp -rf {$this->update['down_path']}/* {$temp_path}/ && cd {$temp_path}/ && mv Nginx.txt nginx.conf && rm -rf *.url *.txt");
        $this->editKey($temp_path);
        $this->editApi($temp_path);
        mk_zip($name, $temp_path);
        return $name;
    }

    /**
     * 编辑Key文件
     * @param string $ext_path 解包后的目录(不含文件)
     *
     */
    private function editKey($ext_path)
    {
        $key_name = $ext_path . '/chevereto/app/license/key.php';
        $key_php  = file_get_contents($key_name);
        if ($key_php === false) {
            exit('无法打开授权信息文件!');
        }
        $key_php = explode(PHP_EOL, $key_php);
        foreach ($key_php as &$val) {
            if (strpos($val, '$license') !== false && strpos($val, ':') !== false && strpos($val, '\'') !== false && strpos($val, ';') !== false) {
                $domain = get_domain($this->request->post('domain'));
                $domain = 'https://' . $domain;
                $key    = build_key($domain);
                $val    = "\$license = '{$key}';";
            }
            // $val .= PHP_EOL;
        }
        $key_php = implode(PHP_EOL, $key_php);
        return file_put_contents($key_name, $key_php);
    }

    /**
     * 编辑检查更新文件
     * @param string $ext_path 解包后的目录(不含文件)
     */
    private function editApi($ext_path)
    {
        $file_name = $ext_path . '/chevereto/app/lib/classes/class.settings.php';
        $api_php   = file_get_contents($file_name);
        if ($api_php === false) {
            exit('无法打开授权信息文件!');
        }
        $api_php = explode(PHP_EOL, $api_php);
        $domain  = Config::get('web_url');
        foreach ($api_php as &$val) {
            if (strpos($val, '$api') !== false && strpos($val, 'chevereto.com/api/') !== false) {
                $val = "		\$api = '{$domain}/api/';";
            } elseif (strpos($val, 'label') !== false && strpos($val, 'defined(') !== false) {
                $val = "                'label'=>'{$domain}',";
            } elseif (strpos($val, 'url') !== false && strpos($val, 'defined(') !== false) {
                $val = "                'url'=>'{$domain}',";
            }
            // $val .= PHP_EOL;
        }
        $api_php = implode(PHP_EOL, $api_php);
        return file_put_contents($file_name, $api_php);
    }
}
