<?php

namespace app\control\controller;

use think\Config;
use think\Controller;
use think\Loader;

class Package extends Controller
{
    public function index()
    {

    }

    public function update()
    {
        $config     = Config::get('c_url.api');
        $url        = $config['get']['info'];
        $header     = [CURLOPT_REFERER => Config::get('c_domain')];
        $json_array = json_decode(fetch_url($url, false, $header), true);

        if (empty($json_array) || $json_array['status_code'] != 200) {
            exif_read_data('版本更新检查失败!');
        }

        $update    = Loader::model('Update');
        $last_info = $update->getLastVersion();
        if (!empty($last_info) && ($last_info >= get_int_version($json_array['software']['current_version']))) {
            exit('最新版本无需更新');
        }
        // var_dump($last_info, get_int_version($json_array['software']['current_version']));exit;
        $data = [
            'update_version'     => get_int_version($json_array['software']['current_version']),
            'update_version_raw' => $json_array['software']['current_version'],
            'build_date'         => $json_array['software']['build_date'],
            'release_notes'      => $json_array['software']['release_notes'],
        ];
        $update->addVersion($data);
        $zip_path = $this->down($data['update_version_raw']);
        $ext_path = APP_PATH . '../save/ext/' . $data['update_version_raw'];
        unzip($zip_path, $ext_path);
        $this->saveSuccess($data['update_version_raw'], $ext_path);
        exit("获取新版本下载包成功,版本号:{$data['update_version_raw']}");
    }

    private function down($version = null)
    {
        $version            = $version ?? $this->request->post('version/d', 'latest');
        $zip_local_filename = 'chevereto_' . $version . '_' . md5(time()) . '.zip';

        $config      = Config::get('c_url.api');
        $url         = $config['download'] . '/' . $version . '/?license=' . Config::get('c_license');
        $header      = [CURLOPT_REFERER => Config::get('c_domain')];
        $download    = fetch_url($url, false, $header);
        $json_decode = json_decode($download);
        // var_dump($json_decode);exit;
        if (json_last_error() == JSON_ERROR_NONE) { // json return means no inline download
            exit('授权无效');
        }

        $save_dir = APP_PATH . '../save/raw/' . $zip_local_filename;
        //保存原生压缩包
        if (file_put_contents($save_dir, $download) === false) {
            exit('无法保存文件');
        }
        return $save_dir;

    }

    /**
     * 保存最新版本文件路径
     * @param string $version 版本号
     * @param string $name 储存路径
     */
    private function saveSuccess($version, $name)
    {
        $update = Loader::model('Update');

        if ($version == 'latest') {
            $version = $update->getLastVersion(0);
        } else {
            $version = get_int_version($version);
        }
        // var_dump($version);
        $update->downSuccess($version, $name);
    }

}
